[fuel] Handle os cacert for baremetal deployments
[releng.git] / utils / fetch_os_creds.sh
1 #!/bin/bash
2 ##############################################################################
3 # Copyright (c) 2015 Ericsson AB and others.
4 # jose.lausuch@ericsson.com
5 # All rights reserved. This program and the accompanying materials
6 # are made available under the terms of the Apache License, Version 2.0
7 # which accompanies this distribution, and is available at
8 # http://www.apache.org/licenses/LICENSE-2.0
9 ##############################################################################
10 set -o errexit
11 set -o nounset
12 set -o pipefail
13
14 usage() {
15     echo "usage: $0 [-v] -d <destination> -i <installer_type> -a <installer_ip> [-o <os_cacert>] [-s <ssh_key>]" >&2
16     echo "[-v] Virtualized deployment" >&2
17     echo "[-s <ssh_key>] Path to ssh key. For MCP deployments only" >&2
18 }
19
20 info ()  {
21     logger -s -t "fetch_os_creds.info" "$*"
22 }
23
24
25 error () {
26     logger -s -t "fetch_os_creds.error" "$*"
27     exit 1
28 }
29
30
31 verify_connectivity() {
32     local ip=$1
33     info "Verifying connectivity to $ip..."
34     for i in $(seq 0 10); do
35         if ping -c 1 -W 1 $ip > /dev/null; then
36             info "$ip is reachable!"
37             return 0
38         fi
39         sleep 1
40     done
41     error "Can not talk to $ip."
42 }
43
44
45 swap_to_public() {
46     if [ "$1" != "" ]; then
47         info "Exchanging keystone public IP in rc file to $public_ip"
48         sed -i  "/OS_AUTH_URL/c\export OS_AUTH_URL=\'$public_ip'" $dest_path
49         sed -i 's/internalURL/publicURL/g' $dest_path
50     fi
51 }
52
53
54 : ${DEPLOY_TYPE:=''}
55
56 #Get options
57 while getopts ":d:i:a:h:s:o:v" optchar; do
58     case "${optchar}" in
59         d) dest_path=${OPTARG} ;;
60         i) installer_type=${OPTARG} ;;
61         a) installer_ip=${OPTARG} ;;
62         s) ssh_key=${OPTARG} ;;
63         o) os_cacert=${OPTARG} ;;
64         v) DEPLOY_TYPE="virt" ;;
65         *) echo "Non-option argument: '-${OPTARG}'" >&2
66            usage
67            exit 2
68            ;;
69     esac
70 done
71
72 # set vars from env if not provided by user as options
73 dest_path=${dest_path:-$HOME/opnfv-openrc.sh}
74 os_cacert=${os_cacert:-$HOME/os_cacert}
75 installer_type=${installer_type:-$INSTALLER_TYPE}
76 installer_ip=${installer_ip:-$INSTALLER_IP}
77 if [ "${installer_type}" == "fuel" ] && [ "${BRANCH}" == "master" ]; then
78     installer_ip=${SALT_MASTER_IP}
79 fi
80
81 if [ -z $dest_path ] || [ -z $installer_type ] || [ -z $installer_ip ]; then
82     usage
83     exit 2
84 fi
85
86 # Checking if destination path is valid
87 if [ -d $dest_path ]; then
88     error "Please provide the full destination path for the credentials file including the filename"
89 else
90     # Check if we can create the file (e.g. path is correct)
91     touch $dest_path || error "Cannot create the file specified. Check that the path is correct and run the script again."
92 fi
93
94
95 ssh_options="-o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no"
96
97 # Start fetching the files
98 if [ "$installer_type" == "fuel" ]; then
99     verify_connectivity $installer_ip
100     if [ "${BRANCH}" == "master" ]; then
101         ssh_key=${ssh_key:-$SSH_KEY}
102         if [ -z $ssh_key ] || [ ! -f $ssh_key ]; then
103             error "Please provide path to existing ssh key for mcp deployment."
104             exit 2
105         fi
106         ssh_options+=" -i ${ssh_key}"
107
108         # retrieving controller vip
109         controller_ip=$(ssh 2>/dev/null ${ssh_options} ubuntu@${installer_ip} \
110             "sudo salt --out txt 'ctl*' pillar.get _param:openstack_control_address | awk '{print \$2; exit}'" | \
111             sed 's/ //g') &> /dev/null
112
113         info "Fetching rc file from controller $controller_ip..."
114         ssh ${ssh_options} ubuntu@${controller_ip} "sudo cat /root/keystonercv3" > $dest_path
115
116         if [[ $BUILD_TAG =~ "baremetal" ]]; then
117             ssh ${ssh_options} ubuntu@${installer_ip} "cat /etc/ssl/certs/os_cacert" > $os_cacert
118         fi
119     else
120         #ip_fuel="10.20.0.2"
121         env=$(sshpass -p r00tme ssh 2>/dev/null ${ssh_options} root@${installer_ip} \
122             'fuel env'|grep operational|head -1|awk '{print $1}') &> /dev/null
123         if [ -z $env ]; then
124             error "No operational environment detected in Fuel"
125         fi
126         env_id="${FUEL_ENV:-$env}"
127
128         # Check if controller is alive (online='True')
129         controller_ip=$(sshpass -p r00tme ssh 2>/dev/null ${ssh_options} root@${installer_ip} \
130             "fuel node --env ${env_id} | grep controller | grep 'True\|  1' | awk -F\| '{print \$5}' | head -1" | \
131             sed 's/ //g') &> /dev/null
132
133         if [ -z $controller_ip ]; then
134             error "The controller $controller_ip is not up. Please check that the POD is correctly deployed."
135         fi
136
137         info "Fetching rc file from controller $controller_ip..."
138         sshpass -p r00tme ssh 2>/dev/null ${ssh_options} root@${installer_ip} \
139             "scp ${ssh_options} ${controller_ip}:/root/openrc ." &> /dev/null
140         sshpass -p r00tme scp 2>/dev/null ${ssh_options} root@${installer_ip}:~/openrc $dest_path &> /dev/null
141     fi
142     #convert to v3 URL
143     auth_url=$(cat $dest_path|grep AUTH_URL)
144     if [[ -z `echo $auth_url |grep v3` ]]; then
145         auth_url=$(echo $auth_url |sed "s|'$|v3&|")
146     fi
147     sed -i '/AUTH_URL/d' $dest_path
148     echo $auth_url >> $dest_path
149
150 elif [ "$installer_type" == "apex" ]; then
151     verify_connectivity $installer_ip
152
153     # The credentials file is located in the Instack VM (192.0.2.1)
154     # NOTE: This might change for bare metal deployments
155     info "Fetching rc file from Instack VM $installer_ip..."
156     if [ -f /root/.ssh/id_rsa ]; then
157         chmod 600 /root/.ssh/id_rsa
158     fi
159     sudo scp $ssh_options root@$installer_ip:/home/stack/overcloudrc.v3 $dest_path
160
161 elif [ "$installer_type" == "compass" ]; then
162     if [ "${BRANCH}" == "master" ]; then
163         sudo docker cp compass-tasks:/opt/openrc $dest_path &> /dev/null
164         sudo chown $(whoami):$(whoami) $dest_path
165         sudo docker cp compass-tasks:/opt/os_cacert $os_cacert &> /dev/null
166     else
167         verify_connectivity $installer_ip
168         controller_ip=$(sshpass -p'root' ssh 2>/dev/null $ssh_options root@${installer_ip} \
169             'mysql -ucompass -pcompass -Dcompass -e"select *  from cluster;"' \
170             | awk -F"," '{for(i=1;i<NF;i++)if($i~/\"127.0.0.1\"/) {print $(i+2);break;}}'  \
171             | grep -oP "\d+.\d+.\d+.\d+")
172
173         if [ -z $controller_ip ]; then
174             error "The controller $controller_ip is not up. Please check that the POD is correctly deployed."
175         fi
176
177         info "Fetching rc file from controller $controller_ip..."
178         sshpass -p root ssh 2>/dev/null $ssh_options root@${installer_ip} \
179             "scp $ssh_options ${controller_ip}:/opt/admin-openrc.sh ." &> /dev/null
180         sshpass -p root scp 2>/dev/null $ssh_options root@${installer_ip}:~/admin-openrc.sh $dest_path &> /dev/null
181
182         info "This file contains the mgmt keystone API, we need the public one for our rc file"
183
184         if grep "OS_AUTH_URL.*v2" $dest_path > /dev/null 2>&1 ; then
185             public_ip=$(sshpass -p root ssh $ssh_options root@${installer_ip} \
186                 "ssh ${controller_ip} 'source /opt/admin-openrc.sh; openstack endpoint show identity '" \
187                 | grep publicurl | awk '{print $4}')
188         else
189             public_ip=$(sshpass -p root ssh $ssh_options root@${installer_ip} \
190                 "ssh ${controller_ip} 'source /opt/admin-openrc.sh; \
191                      openstack endpoint list --interface public --service identity '" \
192                 | grep identity | awk '{print $14}')
193         fi
194         info "public_ip: $public_ip"
195         swap_to_public $public_ip
196     fi
197
198 elif [ "$installer_type" == "joid" ]; then
199     # do nothing...for the moment
200     # we can either do a scp from the jumphost or use the -v option to transmit the param to the docker file
201     echo "Do nothing, creds will be provided through volume option at docker creation for joid"
202
203 elif [ "$installer_type" == "foreman" ]; then
204     #ip_foreman="172.30.10.73"
205     controller="oscontroller1.opnfv.com"
206     verify_connectivity $installer_ip
207
208     # Check if controller is alive (here is more difficult to get the ip from a command like "fuel node")
209     sshpass -p vagrant ssh $ssh_options root@${installer_ip} \
210         "sshpass -p Op3nStack ssh $ssh_options root@${controller} 'ls'" &> /dev/null
211     if [ $? -ne 0 ]; then
212         error "The controller ${controller} is not up. Please check that the POD is correctly deployed."
213     fi
214
215     info "Fetching openrc from a Foreman Controller '${controller}'..."
216     sshpass -p vagrant ssh $ssh_options root@${installer_ip} \
217         "sshpass -p Op3nStack scp $ssh_options root@${controller}:~/keystonerc_admin ." &> /dev/null
218     sshpass -p vagrant scp $ssh_options root@${installer_ip}:~/keystonerc_admin $dest_path &> /dev/null
219
220     #This file contains the mgmt keystone API, we need the public one for our rc file
221     admin_ip=$(cat $dest_path | grep "OS_AUTH_URL" | sed 's/^.*\=//' | sed "s/^\([\"']\)\(.*\)\1\$/\2/g" | sed s'/\/$//')
222     public_ip=$(sshpass -p vagrant ssh $ssh_options root@${installer_ip} \
223         "sshpass -p Op3nStack ssh $ssh_options root@${controller} \
224         'source keystonerc_admin;keystone endpoint-list'" \
225         | grep $admin_ip | sed 's/ /\n/g' | grep ^http | head -1) &> /dev/null
226
227 elif [ "$installer_type" == "daisy" ]; then
228     verify_connectivity $installer_ip
229     cluster=$(sshpass -p r00tme ssh 2>/dev/null $ssh_options root@${installer_ip} \
230             "source ~/daisyrc_admin; daisy cluster-list"|grep active|head -1|awk -F "|" '{print $3}') &> /dev/null
231     if [ -z $cluster ]; then
232         echo "No active cluster detected in daisy"
233         exit 1
234     fi
235
236     sshpass -p r00tme scp 2>/dev/null $ssh_options root@${installer_ip}:/etc/kolla/admin-openrc.sh $dest_path &> /dev/null
237
238 else
239     error "Installer $installer is not supported by this script"
240 fi
241
242
243 if [ ! -f $dest_path ]; then
244     error "There has been an error retrieving the credentials"
245 fi
246
247 echo "-------- Credentials: --------"
248 cat $dest_path